# Apple II Disk Browser

### Features
- Cross-platform (Windows, MacOS, Linux)
- Disk formats
    - DOS
    - Prodos
    - Pascal
    - CPM
    - HDV
    - 2mg
    - shrinkIt, gzip, zip
    - hybrid disks
    - woz
    - Unidos
- File Formats
    - Applesoft and Integer Basic
    - Pascal
    - 6502
    - Appleworks
    - Visicalc
    - Graphics files 
- Disk Internals
    - Wizardry
    - Infocom
- Track / Sector / Block display
- Comprehensive disk listing

### Documentation
* [Usage](resources/usage.md)

### Installation
* Install the **latest** version of the [JDK](http://www.oracle.com/technetwork/java/javase/downloads/index.html).
* Download DiskBrowser.jar from the [releases](https://github.com/dmolony/diskbrowser/releases) page.
* Double-click the jar file, or enter 'java -jar DiskBrowser.jar' in the terminal.
* Set your root folder (the top-level folder where you keep your disk images).

### Example Screens
#### Disk listing
Select a disk from the Disk Tree tab to display the catalog and disk layout.
![Disk listing](resources/disk1.png?raw=true "Disk listing")
#### Disk contents
Double-click a disk from the Disk Tree tab and a new tab appears. This tab contains a list of all the files on the disk. Click on a file and the Output panel will display the contents of that file. The disk sectors containing the file will also be highlighted in the Disk Layout panel.
![Disk catalog](resources/disk2.png?raw=true "Disk catalog")
#### Detailed sector display
Click on any sector in the Disk Layout panel and the Output panel will display the contents of that sector. If it is a recognised sector type, it will be formatted for easier reading.
![Sector details](resources/sector.png?raw=true "Sector details")
#### Cross-platform
Java runs on Windows, MacOS and Linux.
  
![Windows](resources/windows.png?raw=true "Windows")
#### Graphics 
![Graphics](resources/graphics.png?raw=true "Graphics")
#### Applesoft Formatting and Analysis
![Applesoft](resources/basic.png?raw=true "Applesoft")
#### Pascal code
![Pascal](resources/pascal.png?raw=true "Pascal")
#### Infocom
![Infocom](resources/zork.png?raw=true "Infocom")
#### Wizardry
![Wizardry](resources/wizardry.png?raw=true "Wizardry")
#### Visicalc
![Visicalc](resources/visicalc.png?raw=true "Visicalc")
#### Complete Disk List
![Disk List](resources/disklist.png?raw=true "Disk List")
